diff --git a/target/linux/realtek/files-5.10/drivers/net/dsa/rtl83xx/Kconfig b/target/linux/realtek/files-5.10/drivers/net/dsa/rtl83xx/Kconfig
index b423d2c3ea58..79146599180e 100644
--- a/target/linux/realtek/files-5.10/drivers/net/dsa/rtl83xx/Kconfig
+++ b/target/linux/realtek/files-5.10/drivers/net/dsa/rtl83xx/Kconfig
@@ -1,7 +1,7 @@
 # SPDX-License-Identifier: GPL-2.0-only
 config NET_DSA_RTL83XX
 	tristate "Realtek RTL838x/RTL839x switch support"
-	depends on RTL838X
+	depends on MACH_REALTEK_RTL
 	select NET_DSA_TAG_TRAILER
 	help
 	  This driver adds support for Realtek RTL83xx series switching.
diff --git a/target/linux/realtek/patches-5.10/301-gpio-add-rtl8231-driver.patch b/target/linux/realtek/patches-5.10/301-gpio-add-rtl8231-driver.patch
index 496d3f41627b..57334e472443 100644
--- a/target/linux/realtek/patches-5.10/301-gpio-add-rtl8231-driver.patch
+++ b/target/linux/realtek/patches-5.10/301-gpio-add-rtl8231-driver.patch
@@ -6,7 +6,7 @@
  
 +config GPIO_RTL8231
 +	tristate "RTL8231 GPIO"
-+	depends on RTL838X
++	depends on MACH_REALTEK_RTL
 +	help
 +	  Say yes here to support Realtek RTL8231 GPIO expansion chips.
 +
diff --git a/target/linux/realtek/patches-5.10/303-gpio-update-dependencies-for-gpio-realtek-otto.patch b/target/linux/realtek/patches-5.10/303-gpio-update-dependencies-for-gpio-realtek-otto.patch
deleted file mode 100644
index 4ff98e44e8a1..000000000000
--- a/target/linux/realtek/patches-5.10/303-gpio-update-dependencies-for-gpio-realtek-otto.patch
+++ /dev/null
@@ -1,13 +0,0 @@
---- a/drivers/gpio/Kconfig
-+++ b/drivers/gpio/Kconfig
-@@ -491,8 +491,8 @@ config GPIO_RDA
- 
- config GPIO_REALTEK_OTTO
- 	tristate "Realtek Otto GPIO support"
--	depends on MACH_REALTEK_RTL
--	default MACH_REALTEK_RTL
-+	depends on RTL838X
-+	default RTL838X
- 	select GPIO_GENERIC
- 	select GPIOLIB_IRQCHIP
- 	help
diff --git a/target/linux/realtek/patches-5.10/304-spi-update-dependency-for-spi-realtek-rtl.patch b/target/linux/realtek/patches-5.10/304-spi-update-dependency-for-spi-realtek-rtl.patch
deleted file mode 100644
index 6975bfd2287c..000000000000
--- a/target/linux/realtek/patches-5.10/304-spi-update-dependency-for-spi-realtek-rtl.patch
+++ /dev/null
@@ -1,11 +0,0 @@
---- a/drivers/spi/Makefile
-+++ b/drivers/spi/Makefile
-@@ -94,7 +94,7 @@ obj-$(CONFIG_SPI_QCOM_QSPI)		+= spi-qcom
- obj-$(CONFIG_SPI_QUP)			+= spi-qup.o
- obj-$(CONFIG_SPI_ROCKCHIP)		+= spi-rockchip.o
- obj-$(CONFIG_SPI_RB4XX)			+= spi-rb4xx.o
--obj-$(CONFIG_MACH_REALTEK_RTL)		+= spi-realtek-rtl.o
-+obj-$(CONFIG_RTL838X)			+= spi-realtek-rtl.o
- obj-$(CONFIG_SPI_RPCIF)			+= spi-rpc-if.o
- obj-$(CONFIG_SPI_RSPI)			+= spi-rspi.o
- obj-$(CONFIG_SPI_S3C24XX)		+= spi-s3c24xx-hw.o
diff --git a/target/linux/realtek/patches-5.10/305-irqchip-update-dependency-for-irq-realtek-rtl.patch b/target/linux/realtek/patches-5.10/305-irqchip-update-dependency-for-irq-realtek-rtl.patch
deleted file mode 100644
index 96321f0bba2c..000000000000
--- a/target/linux/realtek/patches-5.10/305-irqchip-update-dependency-for-irq-realtek-rtl.patch
+++ /dev/null
@@ -1,8 +0,0 @@
---- a/drivers/irqchip/Makefile
-+++ b/drivers/irqchip/Makefile
-@@ -114,4 +114,4 @@ obj-$(CONFIG_LOONGSON_PCH_PIC)		+= irq-l
- obj-$(CONFIG_LOONGSON_PCH_MSI)		+= irq-loongson-pch-msi.o
- obj-$(CONFIG_MST_IRQ)			+= irq-mst-intc.o
- obj-$(CONFIG_SL28CPLD_INTC)		+= irq-sl28cpld.o
--obj-$(CONFIG_MACH_REALTEK_RTL)		+= irq-realtek-rtl.o
-+obj-$(CONFIG_RTL838X)			+= irq-realtek-rtl.o
diff --git a/target/linux/realtek/patches-5.10/306-gpio-add-legacy-rtl838x-driver.patch b/target/linux/realtek/patches-5.10/306-gpio-add-legacy-rtl838x-driver.patch
index 1ea8add32bf9..25883c25d7f4 100644
--- a/target/linux/realtek/patches-5.10/306-gpio-add-legacy-rtl838x-driver.patch
+++ b/target/linux/realtek/patches-5.10/306-gpio-add-legacy-rtl838x-driver.patch
@@ -6,7 +6,7 @@
  
 +config GPIO_RTL838X
 +	tristate "RTL838X GPIO"
-+	depends on RTL838X
++	depends on MACH_REALTEK_RTL
 +	help
 +	Say yes here to support RTL838X GPIO on RTL93xx SoCs.
 +
diff --git a/target/linux/realtek/patches-5.10/307-wdt-update-dependency-for-realtek-otto-wdt.patch b/target/linux/realtek/patches-5.10/307-wdt-update-dependency-for-realtek-otto-wdt.patch
deleted file mode 100644
index f4496ed294dd..000000000000
--- a/target/linux/realtek/patches-5.10/307-wdt-update-dependency-for-realtek-otto-wdt.patch
+++ /dev/null
@@ -1,15 +0,0 @@
---- a/drivers/watchdog/Kconfig
-+++ b/drivers/watchdog/Kconfig
-@@ -997,10 +997,10 @@ config RTD119X_WATCHDOG
- 
- config REALTEK_OTTO_WDT
- 	tristate "Realtek Otto MIPS watchdog support"
--	depends on MACH_REALTEK_RTL || COMPILE_TEST
-+	depends on RTL838X
- 	depends on COMMON_CLK
- 	select WATCHDOG_CORE
--	default MACH_REALTEK_RTL
-+	default RTL838X
- 	help
- 	  Say Y here to include support for the watchdog timer on Realtek
- 	  RTL838x, RTL839x, RTL930x SoCs. This watchdog has pretimeout
diff --git a/target/linux/realtek/patches-5.10/702-net-ethernet-add-support-for-rtl838x-ethernet.patch b/target/linux/realtek/patches-5.10/702-net-ethernet-add-support-for-rtl838x-ethernet.patch
index 4c5f397e1063..8a15de087494 100644
--- a/target/linux/realtek/patches-5.10/702-net-ethernet-add-support-for-rtl838x-ethernet.patch
+++ b/target/linux/realtek/patches-5.10/702-net-ethernet-add-support-for-rtl838x-ethernet.patch
@@ -7,7 +7,7 @@
 +
 +config NET_RTL838X
 +	tristate "Realtek rtl838x Ethernet MAC support"
-+	depends on RTL838X
++	depends on MACH_REALTEK_RTL
 +	help
 +	  Say Y here if you want to use the Realtek rtl838x Gbps Ethernet MAC.
 +
diff --git a/target/linux/realtek/patches-5.10/705-add-rtl-phy.patch b/target/linux/realtek/patches-5.10/705-add-rtl-phy.patch
index 3046a6aed51a..6d51b39c1ad8 100644
--- a/target/linux/realtek/patches-5.10/705-add-rtl-phy.patch
+++ b/target/linux/realtek/patches-5.10/705-add-rtl-phy.patch
@@ -6,7 +6,7 @@
  
 +config REALTEK_SOC_PHY
 +	tristate "Realtek SoC PHYs"
-+	depends on RTL838X
++	depends on MACH_REALTEK_RTL
 +	help
 +	  Supports the PHYs found in combination with Realtek Switch SoCs
 +